<?php 
ini_set('display_errors', '1');
ini_set('display_startup_errors', '1');
error_reporting(E_ALL);
$signal = file_get_contents('php://input');
file_put_contents('dxTrade.txt',$signal.PHP_EOL , FILE_APPEND | LOCK_EX);

//exit;
//$signal = 'dxtrade,SHORT,554447,NAS100,0.1,43,38,19504.1,SPT_C118182,n2J@vw%u3,default';
//$signal = 'dxtrade,CLOSESHORT,554447,NAS100,SPT_C118182,n2J@vw%u3,default';
if(trim($signal) != '')
{
    $signal_exp = explode(',',$signal);
    /*echo "<pre>";
    print_r($signal_exp);
    echo "</pre>";*/
    //exit;
    if($signal_exp[0] == 'dxtrade')
    {
        /*if(isset($signal_exp[5]) && isset($signal_exp[6]))
        {*/
            $platform = $signal_exp[0];
            $position = $signal_exp[1];
            $account = $signal_exp[2];
            $instrument = $signal_exp[3];
            if($position == "LONG" || $position == "SHORT")
            {
                $lot_size = @$signal_exp[4];
                $sl_points = @$signal_exp[5];
                $tp_points = @$signal_exp[6];
                $current_price = @$signal_exp[7];
                $username = @$signal_exp[8];
                $password = @$signal_exp[9];
                $domain   = @$signal_exp[10];
            }
            else
            {
                $username = @$signal_exp[4];
                $password = @$signal_exp[5];
                $domain   = @$signal_exp[6];
            }
            
            
            if($instrument == 'NAS100')
            {
                $current_price = (float)@$current_price+28; // to amend price from tradingview to Dxtrade
            }
            elseif($instrument == 'US30')
            {
                $current_price = (float)@$current_price+48; // to amend price from tradingview to Dxtrade
            }
            elseif($instrument == 'UK100')
            {
                $current_price = (float)@$current_price-0.8; // to amend price from tradingview to Dxtrade
            }
            
            
            
            $order_code = time();
            
            if($position == 'LONG') //mp=19000, sl =18000 , tp = 20000
            {
                $side = "BUY";
                $position_effect = 'OPEN';
            }
            elseif($position == 'SHORT') // mp=19000, sl=20000, tp=18000
            {
                $side = "SELL";
                $position_effect = 'OPEN';
            }
            elseif($position == 'CLOSELONG') // close the open trade for that symbol at current price
            {
                $position_effect = 'CLOSE';
                $side = "SELL";
            }
            elseif($position == 'CLOSESHORT') // close the open trade for that symbol at current price
            {
                $position_effect = 'CLOSE';
                $side = "BUY";
            }
            
            
            $login_json = dxTradeLogin($username,$password,$domain);
            $login_arr = json_decode($login_json,true);
            
            if(isset($login_arr['sessionToken']))
            {
                $sessionToken = $login_arr['sessionToken'];      
                /*$orders_json = getOrderDetails($sessionToken,$account);
                echo "<pre>";
                print_r(json_decode($orders_json,true));
                echo "</pre>";
                exit;*/
                if($position == 'LONG')
                {
                    $sl_points = $current_price-$sl_points;
                    $tp_points = $current_price+$tp_points;
                    $group_add = array(
                                    "orders"=>array(
                                            array(
                                                "account"=>"default:".$account,
                                                "orderCode"=>$order_code,
                                                "type"=>"MARKET",
                                                "instrument"=>$instrument,
                                                "quantity"=>$lot_size,
                                                "positionEffect"=>$position_effect,
                                                "side"=>$side,
                                                "tif"=>"GTC"
                                            ),
                                           array(
                                                "account"=>"default:".$account,
                                                "orderCode"=>$order_code.'1',
                                                "type"=>"STOP",
                                                "instrument"=>$instrument,
                                                "positionEffect"=>"CLOSE",
                                                "side"=>"SELL",
                                                "stopPrice"=>$sl_points,
                                                "tif"=>"GTC"
                                                ),
                                            array(
                                                "account"=>"default:".$account,
                                                "orderCode"=>$order_code.'2',
                                                "type"=>"LIMIT",
                                                "instrument"=>$instrument,
                                                "positionEffect"=>"CLOSE",
                                                "side"=>"SELL",
                                                "limitPrice"=>$tp_points,
                                                "tif"=>"GTC",
                                            )
                                        ),
                                        "contingencyType"=>"IF-THEN"
                                    );
                    $group_json = json_encode($group_add);
                    $dxOrder_resp =  dxTradeCreateOrder($sessionToken,$account,$group_json);
                    $dxOrder_arr = json_decode($dxOrder_resp,true);
                    
                    if(isset($dxOrder_arr['orderResponses'][0]['orderId']))
                    {
                        file_put_contents('dxtrade_long_positionID.txt',$dxOrder_arr['orderResponses'][0]['orderId']);
                    }
                    else
                    {
                        file_put_contents('dxtrade_long_positionID.txt','');
                    }
                    /*echo "<br> DX Trade LONG Order <br>";
                    echo "<pre>";
                    print_r($dxOrder_arr);
                    echo "</pre>";
                    exit;*/    
                }
                elseif($position == 'SHORT')
                {
                    $sl_points = $current_price+$sl_points;
                    $tp_points = $current_price-$tp_points;
                    $group_add = array(
                                    "orders"=>array(
                                            array(
                                                "account"=>"default:".$account,
                                                "orderCode"=>$order_code,
                                                "type"=>"MARKET",
                                                "instrument"=>$instrument,
                                                "quantity"=>$lot_size,
                                                "positionEffect"=>$position_effect,
                                                "side"=>$side,
                                                "tif"=>"GTC"
                                            ),
                                           array(
                                                "account"=>"default:".$account,
                                                "orderCode"=>$order_code.'1',
                                                "type"=>"STOP",
                                                "instrument"=>$instrument,
                                                "positionEffect"=>"CLOSE",
                                                "side"=>"BUY",
                                                "stopPrice"=>$sl_points,
                                                "tif"=>"GTC"
                                                ),
                                            array(
                                                "account"=>"default:".$account,
                                                "orderCode"=>$order_code.'2',
                                                "type"=>"LIMIT",
                                                "instrument"=>$instrument,
                                                "positionEffect"=>"CLOSE",
                                                "side"=>"BUY",
                                                "limitPrice"=>$tp_points,
                                                "tif"=>"GTC",
                                            )
                                        ),
                                        "contingencyType"=>"IF-THEN"
                                    );
                        
                    $group_json = json_encode($group_add);
                    $dxOrder_resp =  dxTradeCreateOrder($sessionToken,$account,$group_json);
                    $dxOrder_arr = json_decode($dxOrder_resp,true);
                    
                    if(isset($dxOrder_arr['orderResponses'][0]['orderId']))
                    {
                        file_put_contents('dxtrade_short_positionID.txt',$dxOrder_arr['orderResponses'][0]['orderId']);
                    }
                    else
                    {
                        file_put_contents('dxtrade_short_positionID.txt','');
                    }
                    /*echo "<br> DX Trade SHORT Order <br>";
                    echo "<pre>";
                    print_r($group_add);
                    print_r($dxOrder_arr);
                    echo "</pre>";
                    exit;*/    
                }
                elseif($position == 'CLOSELONG')
                {
                    $long_postion_id = file_get_contents('dxtrade_long_positionID.txt');
                    //exit('here');
                    if($long_postion_id != '')
                    {
                        $closelong_arr = array(
                                        "account"=>"default:".$account,
                                        "orderCode"=>(string)$order_code,
                                        "positionCode"=>$long_postion_id,
                                        "type"=>"MARKET",
                                        "instrument"=>$instrument,
                                        "positionEffect"=>$position_effect,
                                        "side"=>$side,
                                        "tif"=>"GTC"
                                    );
                        $closelong_json = json_encode($closelong_arr);
                        $dxOrder_resp =  dxTradeCreateOrder($sessionToken,$account,$closelong_json);
                        $dxOrder_arr = json_decode($dxOrder_resp,true);
                        
                        /*echo "<br> DX Trade CLOSELONG Order <br>";
                        echo "<pre>";
                        echo "<br>".$closelong_json;
                        print_r($closelong_arr);
                        print_r($dxOrder_arr);
                        echo "</pre>";
                        exit;*/    
                    }
                        
                }
                elseif($position == 'CLOSESHORT')
                {
                    $short_postion_id = file_get_contents('dxtrade_short_positionID.txt');
                    //exit('here');
                    if($short_postion_id != '')
                    {
                        $closeshort_arr = array(
                                        "account"=>"default:".$account,
                                        "orderCode"=>(string)$order_code,
                                        "positionCode"=>$short_postion_id,
                                        "type"=>"MARKET",
                                        "instrument"=>$instrument,
                                        "positionEffect"=>$position_effect,
                                        "side"=>$side,
                                        "tif"=>"GTC"
                                    );
                        $closeshort_json = json_encode($closeshort_arr);
                        $dxOrder_resp =  dxTradeCreateOrder($sessionToken,$account,$closeshort_json);
                        $dxOrder_arr = json_decode($dxOrder_resp,true);
                        
                        /*echo "<br> DX Trade CLOSESHORT Order <br>";
                        echo "<pre>";
                        echo "<br>".$short_postion_id;
                        print_r($closeshort_arr);
                        print_r($dxOrder_arr);
                        echo "</pre>";
                        exit;*/    
                    }
                }
                
            }
            else
            {
                echo "<pre>";
                print_r($login_arr);
                echo "</pre>";
            }
/*        }*/
    }
}

exit;


function dxTradeLogin($username,$password,$domain)
{
    $curl = curl_init();
    curl_setopt_array($curl, array(
      CURLOPT_URL => 'https://trade.gooeytrade.com/dxsca-web/login',
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_ENCODING => '',
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 0,
      CURLOPT_FOLLOWLOCATION => true,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => 'POST',
      //Demo Login
      CURLOPT_POSTFIELDS =>'{
            "username": "'.$username.'",
            "domain":"'.$domain.'",
            "password": "'.$password.'"
        }',
    /*
    Actual Logins
    '{
        "username": "TWE_C14185",
        "domain":"default",
        "password": "w2B#c^453"
    }'*/
      CURLOPT_HTTPHEADER => array(
        'Content-Type: application/json',
        'Accept: application/json',
        'Cookie: DXTFID="4b11e09529643933"; JSESSIONID=C03F0DFA8C55B3D2B7E32124D305D552.jvmroute'
      ),
    ));
    
    $response = curl_exec($curl);
    curl_close($curl);
    return $response;    
}

function dxTradeAddStopLoss($sessionToken,$account_code,$order_json)
{
    $account = urlencode("default:".$account_code);
    $curl = curl_init();
    curl_setopt_array($curl, array(
      CURLOPT_URL => 'https://trade.gooeytrade.com/dxsca-web/accounts/'.$account.'/orders',
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_ENCODING => '',
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 0,
      CURLOPT_FOLLOWLOCATION => true,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => 'PUT',
      CURLOPT_POSTFIELDS =>$order_json,
      CURLOPT_HTTPHEADER => array(
        'Content-Type: application/json',
        'Accept: application/json',
        'Cookie: DXTFID="4b11e09529643933"; JSESSIONID=C03F0DFA8C55B3D2B7E32124D305D552.jvmroute',
        'Authorization:DXAPI '.$sessionToken,
        'If-Match : wqeqw12123'
      ),
    ));
    
    $response = curl_exec($curl);
    $httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
    curl_close($curl);
    echo 'HTTP code: ' . $httpcode;
    return $response;
}

function dxTradeCreateOrder($sessionToken,$account_code,$order_json)
{
    $account = urlencode("default:".$account_code);
    $curl = curl_init();
    curl_setopt_array($curl, array(
      CURLOPT_URL => 'https://trade.gooeytrade.com/dxsca-web/accounts/'.$account.'/orders',
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_ENCODING => '',
      //CURLOPT_HEADER=>true,
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 0,
      CURLOPT_FOLLOWLOCATION => true,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => 'POST',
      CURLOPT_POSTFIELDS =>$order_json,
      CURLOPT_HTTPHEADER => array(
        'Content-Type: application/json',
        'Accept: application/json',
        'Cookie: DXTFID="4b11e09529643933"; JSESSIONID=C03F0DFA8C55B3D2B7E32124D305D552.jvmroute',
        'Authorization:DXAPI '.$sessionToken
      ),
    ));
    
    $response = curl_exec($curl);
    // Separate the header and the body
    /*$header_size = curl_getinfo($curl, CURLINFO_HEADER_SIZE);
    $header = substr($response, 0, $header_size);
    $body = substr($response, $header_size);*/
    
    curl_close($curl);
    
    //echo $response;
   /* echo "Response Headers:\n";
    echo $header;
    exit;
    echo "\n\nResponse Body:\n";
    echo $body;*/
    
    return $response;    
    
}


function getOrderDetails($sessionToken,$account_code)
{
    $account = urlencode("default:".$account_code);
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, 'https://trade.gooeytrade.com/dxsca-web/accounts/orders/history?accounts='.$account);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');
    
    
    $headers = array();
    $headers[] = 'Accept: application/json';
    $headers[] = 'Authorization: DXAPI '.$sessionToken;
    $headers[] = 'Cookie: DXTFID="4b11e09529643933"; JSESSIONID=C03F0DFA8C55B3D2B7E32124D305D552.jvmroute';
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    
    $response = curl_exec($ch);
    if (curl_errno($ch)) {
        echo 'Error:' . curl_error($ch);
    }
    curl_close($ch);
    return $response;
}
?>