<?php 
$signal = file_get_contents('php://input');
file_put_contents('tradeLocker.txt',$signal.PHP_EOL , FILE_APPEND | LOCK_EX);
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

//$signal = "tradelocker,SHORT,703393,2,UK100,0.01,15,10,8224,whalley_nick@hotmail.com,2(U@k2cnVMUk,AQUA,demo";
//$signal = "tradelocker,CLOSESHORT,703393,2,UK100,0.01,whalley_nick@hotmail.com,2(U@k2cnVMUk,AQUA,demo";
if(trim($signal) != '')
{
    $signal_exp = explode(',',$signal);
    /*echo "<pre>";
    print_r($signal_exp);
    echo "</pre>";*/
    //exit;
    if($signal_exp[0] == 'tradelocker')
    {
        $platform = $signal_exp[0];
        $position = $signal_exp[1];
        $account = $signal_exp[2];
        $account_no = $signal_exp[3];
        $instrument = $signal_exp[4];
        $lot_size = @$signal_exp[5];
        if($position == 'SHORT' || $position == 'LONG')
        {
            $sl_points = @$signal_exp[6];
            $tp_points = @$signal_exp[7];
            $current_price = @$signal_exp[8];
            $email = @$signal_exp[9];
            $password = @$signal_exp[10];
            $server = @$signal_exp[11];
            $account_type = @$signal_exp[12];
        }
        else
        {
            $email = @$signal_exp[6];
            $password = @$signal_exp[7];
            $server = @$signal_exp[8];
            $account_type = @$signal_exp[9];
        }
        
        
        if($instrument == 'NAS100')
        {
            $current_price = (float)@$current_price+12; // to amend price from tradingview to tradelocker
        }
        elseif($instrument == 'US30')
        {
            $current_price = (float)@$current_price+1.3; // to amend price from tradingview to tradelocker
        }
        elseif($instrument == 'UK100')
        {
            $current_price = (float)@$current_price+1.5; // to amend price from tradingview to tradelocker
        }
        
        $tradeable_instuments_id = array('NAS100'=>306,'US30'=>309,'UK100'=>308);
        $route_id = 9912; // Trade, 452 = Info
        
        $instrument_id = $tradeable_instuments_id[$instrument];
        
        $jwt_resp = tradeLockerGetJWT($email,$password,$server,$account_type);
        $jwt_arr  = json_decode($jwt_resp,true);
        
        /*echo "<pre>";
        print_r($jwt_arr);
        echo "</pre>";*/
        //exit;
        
        if(isset($jwt_arr['accessToken']))
        {
            $bearer_token = $jwt_arr['accessToken'];
            if($position == 'LONG')
            {
                $sl_points = $current_price-$sl_points;
                $tp_points = $current_price+$tp_points;
                $order_arr = array("qty"=>(float)$lot_size,"routeId"=>9912,"side"=>"buy","stopLoss"=>(int)$sl_points,"stopLossType"=>"absolute","stopPrice"=>(int)$sl_points,"takeProfit"=>(int)$tp_points,"takeProfitType"=>"absolute","tradableInstrumentId"=>$instrument_id,"type"=>"market","validity"=>"IOC");
                $order_json = json_encode($order_arr);
                
                /*echo "<br> Sending JSON <br>";
                echo $order_json."<br>";*/
                
                $order_resp_json = tradeLockerPlaceOrder($bearer_token,$account,$account_no,$order_json,$account_type);
                $order_resp_arr = json_decode($order_resp_json,true);      
                
                /*echo "<pre>";
                print_r($order_resp_arr);
                echo "</pre>";*/
            }
            elseif($position == 'SHORT')
            {
                $sl_points = $current_price+$sl_points;
                $tp_points = $current_price-$tp_points;
                $order_arr = array("qty"=>(float)$lot_size,"routeId"=>9912,"side"=>"sell","stopLoss"=>(int)$sl_points,"stopLossType"=>"absolute","stopPrice"=>(int)$sl_points,"takeProfit"=>(int)$tp_points,"takeProfitType"=>"absolute","tradableInstrumentId"=>$instrument_id,"type"=>"market","validity"=>"IOC");
                $order_json = json_encode($order_arr);
                
                /*echo "<br> Sending JSON <br>";
                echo $order_json."<br>";*/
                
                $order_resp_json = tradeLockerPlaceOrder($bearer_token,$account,$account_no,$order_json,$account_type);
                $order_resp_arr = json_decode($order_resp_json,true);                
                
                /*echo "<pre>";
                print_r($order_resp_arr);
                echo "</pre>";*/
            }
            elseif($position == 'CLOSESHORT')
            {
                $open_positions = tradeLockergetAllOpenPositions($bearer_token,$account,$account_no,$account_type);
                $open_poistions_arr = json_decode($open_positions,true);
                
                /*echo "<pre>";
                print_r($open_poistions_arr);
                echo "</pre>";*/
                //exit;
                if($open_poistions_arr['s'] == 'ok')
                {
                    foreach($open_poistions_arr['d']['positions'] as $key=>$position)
                    {
                        $position_id = $position[0];
                        $tradeable_instrument_id = $position[1];
                        $postion_side = $position[3];
                        
                        if($instrument == 'NAS100' && $tradeable_instrument_id == '306' && $postion_side=='sell')
                        {
                            $close_arr = array("qty"=>$lot_size);
                            $close_json = json_encode($close_arr);
                            echo tradeLockerclosePostionById($bearer_token,$account_no,$position_id,$close_json,$account_type);
                        }
                        elseif($instrument == 'US30' && $tradeable_instrument_id == '309' && $postion_side=='sell')
                        {
                            $close_arr = array("qty"=>$lot_size);
                            $close_json = json_encode($close_arr);
                            echo tradeLockerclosePostionById($bearer_token,$account_no,$position_id,$close_json,$account_type);
                        }
                        elseif($instrument == 'UK100' && $tradeable_instrument_id == '308' && $postion_side=='sell')
                        {
                            $close_arr = array("qty"=>$lot_size);
                            $close_json = json_encode($close_arr);
                            echo tradeLockerclosePostionById($bearer_token,$account_no,$position_id,$close_json,$account_type);
                        }        
                        
                    }
                }
                
                
            }
            elseif($position == 'CLOSELONG')
            {
                $open_positions = tradeLockergetAllOpenPositions($bearer_token,$account,$account_no,$account_type);
                $open_poistions_arr = json_decode($open_positions,true);
                
                /*echo "<pre>";
                print_r($open_poistions_arr);
                echo "</pre>";*/
                //exit;
                if($open_poistions_arr['s'] == 'ok')
                {
                    foreach($open_poistions_arr['d']['positions'] as $key=>$position)
                    {
                        $position_id = $position[0];
                        $tradeable_instrument_id = $position[1];
                        $postion_side = $position[3];
                        
                        if($instrument == 'NAS100' && $tradeable_instrument_id == '306' && $postion_side=='buy')
                        {
                            $close_arr = array("qty"=>$lot_size);
                            $close_json = json_encode($close_arr);
                            echo tradeLockerclosePostionById($bearer_token,$account_no,$position_id,$close_json,$account_type);
                        }
                        elseif($instrument == 'US30' && $tradeable_instrument_id == '309' && $postion_side=='buy')
                        {
                            $close_arr = array("qty"=>$lot_size);
                            $close_json = json_encode($close_arr);
                            echo tradeLockerclosePostionById($bearer_token,$account_no,$position_id,$close_json,$account_type);
                        }
                        elseif($instrument == 'UK100' && $tradeable_instrument_id == '308' && $postion_side=='buy')
                        {
                            $close_arr = array("qty"=>$lot_size);
                            $close_json = json_encode($close_arr);
                            echo tradeLockerclosePostionById($bearer_token,$account_no,$position_id,$close_json,$account_type);
                        }        
                        
                    }
                }
            }
            
        }
        exit;
    }
}

function tradeLockerclosePostionById($bearer_token,$account_no,$position_id,$json,$account_type)
{
    $ch = curl_init();

    curl_setopt($ch, CURLOPT_URL, 'https://'.$account_type.'.tradelocker.com/backend-api/trade/positions/'.$position_id);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'DELETE');
    
    curl_setopt($ch, CURLOPT_POSTFIELDS,$json);
    
    $headers = array();
    $headers[] = 'Accept: application/json';
    $headers[] = 'Authorization: Bearer '.$bearer_token;
    $headers[] = 'Accnum: '.$account_no;
    $headers[] = 'Content-Type: application/json';
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    
    $response = curl_exec($ch);
    if (curl_errno($ch)) {
        echo 'Error:' . curl_error($ch);
    }
    curl_close($ch);
    return $response;
}

function tradeLockergetAllOpenPositions($bearer_token,$account,$account_no,$account_type)
{
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, 'https://'.$account_type.'.tradelocker.com/backend-api/trade/accounts/'.$account.'/positions');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'GET');
    
    
    $headers = array();
    $headers[] = 'Accept: application/json';
    $headers[] = 'Authorization: Bearer '.$bearer_token;
    $headers[] = 'Accnum: '.$account_no;
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    
    $response = curl_exec($ch);
    if (curl_errno($ch)) {
        echo 'Error:' . curl_error($ch);
    }
    curl_close($ch);
    return $response;
}

function tradeLockerPlaceOrder($bearer_token,$account,$account_no,$order_json,$account_type)
{
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, 'https://'.$account_type.'.tradelocker.com/backend-api/trade/accounts/'.$account.'/orders');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS,$order_json);
    
    $headers = array();
    $headers[] = 'Accept: application/json';
    $headers[] = 'Authorization: Bearer '.$bearer_token;
    $headers[] = 'Accnum: '.$account_no;
    $headers[] = 'Content-Type: application/json';
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    
    $response = curl_exec($ch);
    if (curl_errno($ch)) {
        echo 'Error:' . curl_error($ch);
    }
    curl_close($ch);
    return $response;
}


function tradeLockerGetJWT($email,$password,$server,$account_type)
{
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, 'https://'.$account_type.'.tradelocker.com/backend-api/auth/jwt/token');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, '{"email":"'.$email.'","password":"'.$password.'","server":"'.$server.'"}');
    
    $headers = array();
    $headers[] = 'Accept: application/json';
    $headers[] = 'Content-Type: application/json';
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    
    $response = curl_exec($ch);
    if (curl_errno($ch)) {
        echo 'Error:' . curl_error($ch);
    }
    curl_close($ch);
    return $response;
}


function tradeLockerGetInstruments($bearer_token,$account_id,$account_no)
{
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, 'https://demo.tradelocker.com/backend-api/trade/accounts/'.$account_id.'/instruments');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    $headers = array();
    $headers[] = 'Accept: application/json';
    $headers[] = 'Content-Type: application/json';
    $headers[] = 'Authorization: Bearer '.$bearer_token;
    $headers[] = 'accNum: '.$account_no;
    
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    $response = curl_exec($ch);
    if (curl_errno($ch)) {
        echo 'Error:' . curl_error($ch);
    }
    curl_close($ch);
    return $response;
}

?>